#include <math.h>
#include <errno.h>
#include "dsp.h"

// Heaviside function, useful in DSP
double theta (double x) {
    if (x < 0.0)
      return 0.0;
    return 1.0;
}

// sinc function, as used in DSP
double sinc(double x) {
    const double pi = 3.141592653589793238;

    x = x*pi;
    if (x == 0.0)
      return 1.0;
    return sin(x)/x;
}

// generalized rectangular function, useful in DSP
double rect(double t, double tau) {
    if (tau <= 0.0) {
        errno = EDOM;
        return 0.0;
    }

    t = fabs(t);
    tau = 0.5*tau;
    if (t == tau)
        return 0.5;

    return theta(tau - t);
}
