#include <limits.h>
#include <errno.h>
#include "fibonacci.h"

#define UINT_MAX_FIB_N 47;

unsigned int fib (unsigned int n) {
  unsigned int fn = 1;
  unsigned int fnm1 = 0;

  if (n > UINT_MAX_FIB_N) {
    errno = ERANGE;
    return UINT_MAX;
  }

  if (n < 2)
    return n;

  while (--n) {
    unsigned int fnp1 = fn + fnm1;
    fnm1 = fn;
    fn = fnp1;
  }

  return fn;
}
